unit main;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls, Buttons;

type
  TForm1 = class(TForm)
    grColor: TComboBox;
    Shape1: TShape;
    Panel1: TPanel;
    Shape2: TShape;
    Label6: TLabel;
    Edit4: TEdit;
    Edit5: TEdit;
    Edit6: TEdit;
    Edit7: TEdit;
    Label7: TLabel;
    Panel2: TPanel;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Button1: TButton;
    Button2: TButton;
    Edit1: TEdit;
    Edit2: TEdit;
    Edit3: TEdit;
    ComboBox1: TComboBox;
    Label8: TLabel;
    Edit8: TEdit;
    Label9: TLabel;
    BitBtn1: TBitBtn;
    BitBtn2: TBitBtn;
    BitBtn3: TBitBtn;
    procedure Button1Click(Sender: TObject);
    procedure grColorChange(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure BitBtn1Click(Sender: TObject);
    procedure BitBtn2Click(Sender: TObject);
    procedure BitBtn3Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

{ }
const Nparam = 5; {   }
      tabTitles: array [0..4] of string[5] = ('p','teta','Rmin','sigma','Dteta');
      tab2Tit='p \ t=';
      NZ1=6; NZ2=3; {   }
      neopred=-1000;{       }
      myScreenX=520; myScreenY=(3*myScreenX) div 4; {  }
      Narg=1; Nfunc=3; { ,     }

implementation

uses graph, tabl1, tabl2, rez_graph;

{$R *.DFM}

var x,y,Vy,Vx,t,tp,a,p,e,k3,dt:double; { }
    mnogo,myStop:boolean; { .    }

{}
function ax(x,y,t:real):double;
begin ax:=x/(sqrt(x*x+y*y)*(x*x+y*y));end;
function ay(x,y,t:real):double;
begin ay:=y/(sqrt(x*x+y*y)*(x*x+y*y));end;
{ }
procedure nachsost(Pnach,Xnach:double);
begin t:=0;x:=Xnach;p:=pnach;y:=p;Vx:=1;Vy:=0;tab2AddValue(0.5)
 end;
{     }
procedure trace(gr:boolean);
begin vx:=vx+ax(x,y,t)*dt;
       x:=x+vx*dt;
      vy:=vy+ay(x,y,t)*dt;
       y:=y+vy*dt;
      if gr then grPutPixel(x,y);
end;
{  }
procedure integr;
begin {param[0]:=v0;} param[1]:=e; param[2]:=tp; param[3]:=a; param[4]:=k3;
      tabLine; {   }
end;

procedure buttons(b:boolean);
begin {  ""  "" (" ")}
with Form1 do
     begin BitBtn3.Enabled:=b;     {""}
           Button1.Enabled:=not b; {"" - 1 }
           Button2.Enabled:=not b; {"" -  }
     end;
end;

procedure graphic1(mnogo:boolean);
var v1,v2,v3,vh,X0,s,Tprint,tpr:double;
    i,n:integer;
    gr:boolean;
begin X0:=-39; if mnogo then { }
         begin v2:=StrToFloat(Form1.Edit2.Text); {}
               v3:=StrToFloat(Form1.Edit3.Text); {}
               n:=Form1.ComboBox1.ItemIndex+2;{ .}
               vh:=(v3-v2)/(n-1);{} p:=v2;{. }
         end   else {1 }
         begin v1:=StrToFloat(Form1.Edit1.Text);
               p:=v1;{.  }
               n:=1;{1 .} vh:=0{}
         end;
      dt:=StrToFloat(Form1.Edit8.Text);  {  }
      Tprint:=StrToFloat(form4.edit2.Text);
      myStop:=false; buttons(true); {  ""}
      i:=1;  { }
      repeat {n }
             ClearLastPoint; { .  }
                      nachsost(p,x0);{ } e:=0;
                      {T, a  K3   }
                      tp:=-x0; a:=neopred; k3:=neopred;
                      param[0]:=p;
                       tpr:=Tprint;

                       gr:=true;
                      repeat { }
                             t:=t+dt; trace(gr); {  }
                             a:=sqrt(x*x+y*y);{  }
                             if a<tp then tp:=a;
                             if (t>=tpr) then
	                      begin s:=0.5*(vx*vx+vy*vy); tpr:=tpr+Tprint;
                                      tab2AddValue(s);
                              end;

                             {  }
                             Application.ProcessMessages;
                      until (a>40){  }
                            or myStop; {  ""}
                     e:=arctan(vy/vx);if (p>0)and(e<0) then e:=e+pi;
                      if (p<0)and (e>0)then e:=e-pi;
                      {  }
                      p:=p+0.001; nachsost(p,x0); gr:=false;
                      repeat { }
                             {xold:=x;yold:=y;{ . . }
                             t:=t+dt; trace(gr); {  }
                             a:=sqrt(x*x+y*y);{  }
                             {  }
                             Application.ProcessMessages;
                      until (a>40){  }
                            or myStop; {  ""}
                      s:=arctan(vy/vx);if (p>0)and(s<0) then s:=s+pi;
                      if (p<0)and (s>0)then s:=s-pi;
                      k3:=180*abs(e-s)/(pi*0.001);p:=p-0.001;
                      if sin(e)<>0 then a:=0.001*p/abs(e-s)/sin(e)
                              else begin a:=neopred; k3:=neopred end;
                              e:=180*e/pi;
                      integr; {  }
                      tab2NextLine;
                p:=p+vh; i:=i+1; {  }
      until (i>n) or myStop; {   .   }
      buttons(false); {  ""  ""   .}
end;
 procedure ShowWin;
begin form3.show; {    1}

      form2.show; {   }
      grSetSize(myScreenX,myScreenY); {  . }
      centr_krug;
      
      form4.show; {    2}
      form5.show;

      Form1.SetFocus; {    }
end;

procedure TForm1.Button1Click(Sender: TObject);
begin ShowWin; { }
      mnogo:=false; graphic1(mnogo); { 1 }
end;

procedure TForm1.Button2Click(Sender: TObject);
begin ShowWin; { }
      mnogo:=true; graphic1(mnogo); {  }
end;

procedure TForm1.BitBtn1Click(Sender: TObject);
begin  tabClearVal; {   1}
       tab2ClearVal
end;

procedure TForm1.BitBtn2Click(Sender: TObject);
begin { }
with form2.Image1 do Canvas.FillRect(Rect(0,0,width,height));
end;

procedure TForm1.BitBtn3Click(Sender: TObject);
{     }
begin myStop:=true
end;

procedure TForm1.grColorChange(Sender: TObject);
begin {  }
case grColor.ItemIndex of
     0:grCurColor:=clBlack;
     1:grCurColor:=clMaroon;
     2:grCurColor:=clGreen;
     3:grCurColor:=clOlive;
     4:grCurColor:=clNavy;
     5:grCurColor:=clPurple;
     6:grCurColor:=clTeal;
     7:grCurColor:=clGray;
     8:grCurColor:=clSilver;
     9:grCurColor:=clRed;
     10:grCurColor:=clLime;
     11:grCurColor:=clYellow;
     12:grCurColor:=clBlue;
     13:grCurColor:=clFuchsia;
     14:grCurColor:=clAqua;
     15:grCurColor:=clWhite;
end;{case}
Shape1.Brush.Color:=grCurColor;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
with Form1 do {  }
     begin top:=0; left:=(screen.Width-width) div 2;
     end;
grColor.ItemIndex:=0; Shape1.Brush.Color:=clBlack; { }
combobox1.ItemIndex:=9; { }
end;

end.
