unit graph;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls;

type
  TForm2 = class(TForm)
    Image1: TImage;
    procedure FormCreate(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form2: TForm2;

grCurColor: TColor;

procedure grSetSize(x,y: integer);
procedure centr_krug;
procedure grPutPixel(x,y: double);
procedure grPutPoint(x,y: double);
procedure grLine(x1,y1,x2,y2: double);
procedure ClearLastPoint;

implementation

uses main, tabl1;

{$R *.DFM}

var Mx,My,X0,Y0:double; {,  . }
    Ymax, LastPointX,LastPointY:integer;

procedure grSetSize(x,y: integer);
{   }
var dx,dy:double; xa,ya:integer;
begin Form2.ClientWidth:=x;
      Form2.ClientHeight:=y; {}
      {     }
      form2.left:=screen.Width-Form2.Width;
      Ymax:=y;
      { .     . }
      X0:=StrToFloat(Form1.Edit4.Text);
      Y0:=StrToFloat(Form1.Edit6.Text);
      dx:=StrToFloat(Form1.Edit5.Text)-X0;
      dy:=StrToFloat(Form1.Edit7.Text)-Y0;
      Mx:=x/dx; My:=y/dy; {: /.}
      with Form2.Image1.Canvas do { }
           begin xa:=round(y+y0*My);
                 MoveTo(0,xa); LineTo(x,xa); {X}
                 ya:=round(-x0*Mx);
                 MoveTo(ya,0); LineTo(ya,y); {Y}
           end;
end;

procedure centr_krug; {    }
begin
Form2.Image1.Canvas.Ellipse(round((-1-X0)*Mx),Ymax-round((1-Y0)*My),round((1-X0)*Mx),Ymax-round((-1-Y0)*My));
end;

procedure grPutPixel(x,y: double);
var xp,yp:integer;
begin xp:=round((x-X0)*Mx); yp:=Ymax-round((y-Y0)*My); { }
      {      ?}
      if (LastPointX=xp) and (LastPointY=yp) then exit;
      {    . }
      if (xp<0) or (xp>Form2.Image1.Width) then exit;
      if (yp<0) or (yp>Form2.Image1.Height) then exit;
      {   }
      LastPointX:=xp; LastPointY:=yp;
      {   }
      Form2.Image1.Canvas.Pixels[xp,yp]:=grCurColor;
end;

procedure grPutPoint(x,y: double);
const r=2;
var xp,yp:integer;
begin xp:=round((x-X0)*Mx); yp:=Ymax-round((y-Y0)*My); { }
    (*  {      ?}
      if (LastPointX=xp) and (LastPointY=yp) then exit;
      {    . }
      if (xp<0) or (xp>Form2.Image1.Width) then exit;
      if (yp<0) or (yp>Form2.Image1.Height) then exit;
      {   }
      LastPointX:=xp; LastPointY:=yp; *)
      {   }
      Form2.Image1.Canvas.Pen.Color:=grCurColor;
      Form2.Image1.Canvas.Ellipse(xp-r,yp+r,xp+r,yp-r)
end;

procedure grLine(x1,y1,x2,y2: double);
var xp,yp:integer;
begin xp:=round((x1-X0)*Mx); yp:=Ymax-round((y1-Y0)*My); { }
      Form2.Image1.Canvas.MoveTo(xp,yp);
      xp:=round((x2-X0)*Mx); yp:=Ymax-round((y2-Y0)*My); { }
      Form2.Image1.Canvas.LineTo(xp,yp)
end;

procedure ClearLastPoint;
{     (-1  !)}
begin LastPointX:=-1; LastPointY:=-1;
end;

procedure TForm2.FormCreate(Sender: TObject);
{   }
begin top:=form1.top+form1.height;
end;

initialization
ClearLastPoint{    }

end.
