unit main;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls, Buttons;

type
  TForm1 = class(TForm)
    grColor: TComboBox;
    Shape1: TShape;
    Panel1: TPanel;
    Shape2: TShape;
    Label6: TLabel;
    Edit4: TEdit;
    Edit5: TEdit;
    Edit6: TEdit;
    Edit7: TEdit;
    Label7: TLabel;
    Panel2: TPanel;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Button1: TButton;
    Button2: TButton;
    Edit1: TEdit;
    Edit2: TEdit;
    Edit3: TEdit;
    ComboBox1: TComboBox;
    Label8: TLabel;
    Edit8: TEdit;
    Label9: TLabel;
    BitBtn1: TBitBtn;
    BitBtn2: TBitBtn;
    BitBtn3: TBitBtn;
    procedure Button1Click(Sender: TObject);
    procedure grColorChange(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure BitBtn1Click(Sender: TObject);
    procedure BitBtn2Click(Sender: TObject);
    procedure BitBtn3Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

{ }
const Nparam = 4; {   }
      tabTitles: array [0..3] of string[4] = (' dt ','Tmax',' T2 ',' T1 ');
      NZ1=6; NZ2=3; {   }
      neopred=-1000;{       }
      myScreenX=520; myScreenY=(3*myScreenX) div 4; {  }

implementation

uses graph, tabl1;

{$R *.DFM}

var y,tmax,t,dt:double; { }
    myStop:boolean; { .    }

{ }
procedure nachsost;
begin t:=0;y:=1 end;

{     }
procedure trace;
begin y:=y-y*dt; grPutPixel(t,y);
end;

procedure buttons(b:boolean);
begin {  ""  "" (" ")}
with Form1 do
     begin BitBtn3.Enabled:=b;     {""}
           Button1.Enabled:=not b; {"" - 1 }
     end;
end;

procedure graphic1;
var   s:double;
begin dt:=StrToFloat(Form1.Edit8.Text);  {  }
      tmax:=StrToFloat(Form1.Edit1.Text);{,   }
      myStop:=false; buttons(true); {  ""}
      param[0]:=dt; param[1]:=tmax; { }
      ClearLastPoint; { .  }
      nachsost;{ } s:=0;
      repeat { }
             t:=t+dt; trace; {  }
             s:=s+t*y; { }
             if y>0.5 then param[2]:=t; { }
             Application.ProcessMessages; {  }
      until (t>tmax)   { }
            or myStop; {  ""}
      s:=dt*s; param[3]:=s; tabLine;
      buttons(false); {  ""  ""   .}
end;

procedure ShowWin;
begin form3.show; {    1}

      form2.show; {   }
      grSetSize(myScreenX,myScreenY); {  . }

      Form1.SetFocus; {    }
end;

procedure TForm1.Button1Click(Sender: TObject);
begin ShowWin; { }
      graphic1; { 1 }
end;

procedure TForm1.BitBtn1Click(Sender: TObject);
begin  tabClearVal; {   1}
end;

procedure TForm1.BitBtn2Click(Sender: TObject);
begin { }
with form2.Image1 do Canvas.FillRect(Rect(0,0,width,height));
end;

procedure TForm1.BitBtn3Click(Sender: TObject);
{     }
begin myStop:=true
end;

procedure TForm1.grColorChange(Sender: TObject);
begin {  }
case grColor.ItemIndex of
     0:grCurColor:=clBlack;
     1:grCurColor:=clMaroon;
     2:grCurColor:=clGreen;
     3:grCurColor:=clOlive;
     4:grCurColor:=clNavy;
     5:grCurColor:=clPurple;
     6:grCurColor:=clTeal;
     7:grCurColor:=clGray;
     8:grCurColor:=clSilver;
     9:grCurColor:=clRed;
     10:grCurColor:=clLime;
     11:grCurColor:=clYellow;
     12:grCurColor:=clBlue;
     13:grCurColor:=clFuchsia;
     14:grCurColor:=clAqua;
     15:grCurColor:=clWhite;
end;{case}
Shape1.Brush.Color:=grCurColor;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
with Form1 do {  }
     begin top:=0; left:=(screen.Width-width) div 2;
     end;
grColor.ItemIndex:=0; Shape1.Brush.Color:=clBlack; { }
end;

end.
