unit main;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls, Buttons;

type
  TForm1 = class(TForm)
    grColor: TComboBox;
    Shape1: TShape;
    Panel1: TPanel;
    Shape2: TShape;
    Label6: TLabel;
    Edit4: TEdit;
    Edit5: TEdit;
    Edit6: TEdit;
    Edit7: TEdit;
    Label7: TLabel;
    Panel2: TPanel;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Button1: TButton;
    Button2: TButton;
    Edit1: TEdit;
    Edit2: TEdit;
    Edit3: TEdit;
    ComboBox1: TComboBox;
    Label8: TLabel;
    Edit8: TEdit;
    Label9: TLabel;
    BitBtn1: TBitBtn;
    BitBtn2: TBitBtn;
    BitBtn3: TBitBtn;
    procedure Button1Click(Sender: TObject);
    procedure grColorChange(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure BitBtn1Click(Sender: TObject);
    procedure BitBtn2Click(Sender: TObject);
    procedure BitBtn3Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

{ }
const Nparam = 5; {   }
      tabTitles: array [0..4] of string[2] = ('V0','e','T','a','k3');
      tab2Tit='V0 \ t=';
      NZ1=6; NZ2=3; {   }
      neopred=-1000;{       }
      myScreenX=520; myScreenY=(3*myScreenX) div 4; {  }
      Narg=0; Nfunc=2; { ,     }

implementation

uses graph, tabl1, tabl2, rez_graph;

{$R *.DFM}

var x,y,Vy,Vx,t,tp,a,v0,e,k3,dt:double; { }
    mnogo,myStop:boolean; { .    }

{}
function ax(x,y,t:real):double;
begin ax:=-x/(sqrt(x*x+y*y)*(x*x+y*y));end;
function ay(x,y,t:real):double;
begin ay:=-y/(sqrt(x*x+y*y)*(x*x+y*y));end;
{ }
procedure nachsost(Vnach:double);
begin t:=0;x:=1;y:=0;Vx:=0;V0:=Vnach;Vy:=V0 end;
{     }
procedure trace;
begin vx:=vx+ax(x,y,t)*dt;
       x:=x+vx*dt;
      vy:=vy+ay(x,y,t)*dt;
       y:=y+vy*dt;
      grPutPixel(x,y);
end;
{  }
procedure integr;
begin {param[0]:=v0;} param[1]:=e; param[2]:=tp; param[3]:=a; param[4]:=k3;
      tabLine; {   }
end;

procedure buttons(b:boolean);
begin {  ""  "" (" ")}
with Form1 do
     begin BitBtn3.Enabled:=b;     {""}
           Button1.Enabled:=not b; {"" - 1 }
           Button2.Enabled:=not b; {"" -  }
     end;
end;

procedure graphic1(mnogo:boolean);
var v1,v2,v3,vh,s,Xmin,Ymax,yold,xold,Tprint,tpr:double;
    i,n:integer;
begin if mnogo then { }
         begin v2:=StrToFloat(Form1.Edit2.Text); {}
               v3:=StrToFloat(Form1.Edit3.Text); {}
               n:=Form1.ComboBox1.ItemIndex+2;{ .}
               vh:=(v3-v2)/(n-1);{} v0:=v2;{. }
         end   else {1 }
         begin v1:=StrToFloat(Form1.Edit1.Text);
               v0:=v1;{. }
               n:=1;{1 .} vh:=0{}
         end;
      Xmin:=StrToFloat(Form1.Edit4.Text);{  }
      Ymax:=StrToFloat(Form1.Edit7.Text);{  }
      dt:=StrToFloat(Form1.Edit8.Text);  {  }
      Tprint:=StrToFloat(form4.edit2.Text);
      myStop:=false; buttons(true); {  ""}
      i:=1;  { }
      repeat {n }
             if v0<>0 then {V0=0 -  }
                begin ClearLastPoint; { .  }
                      nachsost(v0);{ } e:=0;
                      {T, a  K3   }
                      tp:=neopred; a:=neopred; k3:=neopred;
                      tpr:=Tprint; s:=0; param[0]:=V0;
                      repeat { }
                             xold:=x;yold:=y;{ . . }
                             t:=t+dt; trace; {  }
                             s:=s+(x*vy-y*vx); { }
                             if (t>=tpr) then
	                        begin s:=0.5*s*dt; tpr:=tpr+Tprint;
                                      tab2AddValue(s); s:=0
                                end;
                             if (xold>0)and(x<=0) then e:=abs(y-1);
                             if (yold>=0)and(y<0)then { T, a  K3}
                                begin tp:=2*t;a:=(1-x)/2;
                                      k3:=tp*tp/(a*a*a);
                                end;
                             {  }
                             Application.ProcessMessages;
                      until (((yold<0)and(y>0)){ } or
                            (((x<Xmin)or(y>Ymax))and(e>1)))
                            {    }
                            or myStop; {  ""}
                      integr; {  }
                      tab2NextLine;
                end; {if v0<>0}
             v0:=v0+vh; i:=i+1; {  }              
      until (i>n) or myStop; {   .   }
      buttons(false); {  ""  ""   .}
end;

procedure ShowWin;
begin form3.show; {    1}

      form2.show; {   }
      grSetSize(myScreenX,myScreenY); {  . }
      
      
      form4.show; {    2}
      form5.show;

      Form1.SetFocus; {    }
end;

procedure TForm1.Button1Click(Sender: TObject);
begin ShowWin; { }
      mnogo:=false; graphic1(mnogo); { 1 }
end;

procedure TForm1.Button2Click(Sender: TObject);
begin ShowWin; { }
      mnogo:=true; graphic1(mnogo); {  }
end;

procedure TForm1.BitBtn1Click(Sender: TObject);
begin  tabClearVal; {   1}
       tab2ClearVal
end;

procedure TForm1.BitBtn2Click(Sender: TObject);
begin { }
with form2.Image1 do Canvas.FillRect(Rect(0,0,width,height));
end;

procedure TForm1.BitBtn3Click(Sender: TObject);
{     }
begin myStop:=true
end;

procedure TForm1.grColorChange(Sender: TObject);
begin {  }
case grColor.ItemIndex of
     0:grCurColor:=clBlack;
     1:grCurColor:=clMaroon;
     2:grCurColor:=clGreen;
     3:grCurColor:=clOlive;
     4:grCurColor:=clNavy;
     5:grCurColor:=clPurple;
     6:grCurColor:=clTeal;
     7:grCurColor:=clGray;
     8:grCurColor:=clSilver;
     9:grCurColor:=clRed;
     10:grCurColor:=clLime;
     11:grCurColor:=clYellow;
     12:grCurColor:=clBlue;
     13:grCurColor:=clFuchsia;
     14:grCurColor:=clAqua;
     15:grCurColor:=clWhite;
end;{case}
Shape1.Brush.Color:=grCurColor;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
with Form1 do {  }
     begin top:=0; left:=(screen.Width-width) div 2;
     end;
grColor.ItemIndex:=0; Shape1.Brush.Color:=clBlack; { }
combobox1.ItemIndex:=8; { }
end;

end.
