unit main;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls, Buttons;

type
  TForm1 = class(TForm)
    grColor: TComboBox;
    Shape1: TShape;
    Panel1: TPanel;
    Shape2: TShape;
    Label6: TLabel;
    Edit4: TEdit;
    Edit5: TEdit;
    Edit6: TEdit;
    Edit7: TEdit;
    Label7: TLabel;
    Panel2: TPanel;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Button1: TButton;
    Button2: TButton;
    Edit1: TEdit;
    Edit2: TEdit;
    Edit3: TEdit;
    ComboBox1: TComboBox;
    Label8: TLabel;
    Edit8: TEdit;
    Label9: TLabel;
    BitBtn1: TBitBtn;
    BitBtn2: TBitBtn;
    BitBtn3: TBitBtn;
    procedure Button1Click(Sender: TObject);
    procedure grColorChange(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure BitBtn1Click(Sender: TObject);
    procedure BitBtn2Click(Sender: TObject);
    procedure BitBtn3Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

{ }
const Nparam = 4; {   }
      tabTitles: array [0..3] of string[5] = ('V0','Amax','T','h');
      tab2Tit='V0 \ t=';
      NZ1=6; NZ2=3; {   }
      neopred=-1000;{       }
      myScreenX=520; myScreenY=(3*myScreenX) div 4; {  }
      Narg=1; Nfunc=2; { ,     }
implementation

uses graph, tabl1, tabl2, rez_graph;

{$R *.DFM}

var x,V,t,tp,a,v0,e,k3,dt:double; { }
    mnogo,myStop:boolean; { .    }

{}
function ax(x:real):double;
begin ax:=-sin(x);end;
{ }
procedure nachsost(Vnach:double);
begin t:=0;x:=0;V0:=Vnach;V:=V0;
       tab2AddValue(0.5*v*v)
end;
{     }
procedure trace;
begin v:=v+ax(x)*dt;
       x:=x+v*dt;
      grPutPixel(t,x);
      grPutPixel(t,v); grPutPixel(x,v);
end;
{  }
procedure integr;
begin {param[0]:=v0;} param[1]:=a; param[2]:=tp; param[3]:=e; param[4]:=k3;
      tabLine; {   }
end;

procedure buttons(b:boolean);
begin {  ""  "" (" ")}
with Form1 do
     begin BitBtn3.Enabled:=b;     {""}
           Button1.Enabled:=not b; {"" - 1 }
           Button2.Enabled:=not b; {"" -  }
     end;
end;

procedure graphic1(mnogo:boolean);
var v1,v2,v3,vh,s,yold,xold,Tprint,tpr:double;
    i,n:integer;
begin if mnogo then { }
         begin v2:=StrToFloat(Form1.Edit2.Text); {}
               v3:=StrToFloat(Form1.Edit3.Text); {}
               n:=Form1.ComboBox1.ItemIndex+2;{ .}
               vh:=(v3-v2)/(n-1);{} v0:=v2;{. }
         end   else {1 }
         begin v1:=StrToFloat(Form1.Edit1.Text);
               v0:=v1;{. }
               n:=1;{1 .} vh:=0{}
         end;
      dt:=StrToFloat(Form1.Edit8.Text);  {  }
      Tprint:=StrToFloat(form4.edit2.Text);
      myStop:=false; buttons(true); {  ""}
      i:=1;  { }
      repeat {n }
             if v0<>0 then {V0=0 -  }
                begin ClearLastPoint; { .  }
                      nachsost(v0);{ } e:=0;
                      {T, a  K3   }
                      tp:=neopred; a:=neopred; k3:=neopred;
                      tpr:=Tprint; param[0]:=V0;
                      repeat { }
                             xold:=x;yold:=v;{ . . }
                             t:=t+dt; trace; {  }
                             if (t>=tpr) then
	                        begin s:=0.5*v*v; tpr:=tpr+Tprint;
                                      tab2AddValue(s)
                                end;
                             if (yold>0)and(v<=0) then
                             { T, a  K3}
                                begin tp:=4*t;a:=180*x/pi;e:=cos(x);
                                if e<0 then e:=1-e; end;
                              if (x>2*pi)and(xold<2*pi) then
                              begin tp:=t;a:=360;e:=2
                                end;
                             {  }
                             Application.ProcessMessages;
                      until (((xold<0)and(x>0))or(x>4*pi)){ 
                        }
                               or myStop; {  ""}
                      integr; {  }
                      tab2NextLine;
                end; {if v0<>0}
             v0:=v0+vh; i:=i+1; {  }              
      until (i>n) or myStop; {   .   }
      buttons(false); {  ""  ""   .}
end;

procedure ShowWin;
begin form3.show; {    1}

      form2.show; {   }
      grSetSize(myScreenX,myScreenY); {  . }

      
      form4.show; {    2}
      form5.show;

      Form1.SetFocus; {    }
end;

procedure TForm1.Button1Click(Sender: TObject);
begin ShowWin; { }
      mnogo:=false; graphic1(mnogo); { 1 }
end;

procedure TForm1.Button2Click(Sender: TObject);
begin ShowWin; { }
      mnogo:=true; graphic1(mnogo); {  }
end;

procedure TForm1.BitBtn1Click(Sender: TObject);
begin  tabClearVal; {   1}
       tab2ClearVal
end;

procedure TForm1.BitBtn2Click(Sender: TObject);
begin { }
with form2.Image1 do Canvas.FillRect(Rect(0,0,width,height));
end;

procedure TForm1.BitBtn3Click(Sender: TObject);
{     }
begin myStop:=true
end;

procedure TForm1.grColorChange(Sender: TObject);
begin {  }
case grColor.ItemIndex of
     0:grCurColor:=clBlack;
     1:grCurColor:=clMaroon;
     2:grCurColor:=clGreen;
     3:grCurColor:=clOlive;
     4:grCurColor:=clNavy;
     5:grCurColor:=clPurple;
     6:grCurColor:=clTeal;
     7:grCurColor:=clGray;
     8:grCurColor:=clSilver;
     9:grCurColor:=clRed;
     10:grCurColor:=clLime;
     11:grCurColor:=clYellow;
     12:grCurColor:=clBlue;
     13:grCurColor:=clFuchsia;
     14:grCurColor:=clAqua;
     15:grCurColor:=clWhite;
end;{case}
Shape1.Brush.Color:=grCurColor;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
with Form1 do {  }
     begin top:=0; left:=(screen.Width-width) div 2;
     end;
grColor.ItemIndex:=0; Shape1.Brush.Color:=clBlack; { }
combobox1.ItemIndex:=8; { }
end;

end.
